<app-admin-title
  [title]="'Products'"
  [showProgressIndicator]="showProgressIndicator"
></app-admin-title>
<p>
  <mat-toolbar class="menu-toolbar">
    <button mat-button (click)="showNewDialog()">
      <fa-icon [icon]="faPlus"></fa-icon> New
    </button>
    <button mat-button [disabled]="clickedRows.size != 1" (click)="showEditDialog()">
      <fa-icon [icon]="faEdit"></fa-icon> Edit
    </button>
    <button mat-button [disabled]="clickedRows.size != 1" (click)="showUploadImageDialog()">
      <fa-icon [icon]="faImage"></fa-icon> Image
    </button>
    <button mat-button [disabled]="clickedRows.size != 1 || locations.length == 0" (click)="showAddLocationDialog()">
      <fa-icon [icon]="faMapPin"></fa-icon> Locations
    </button>
    <button mat-button [disabled]="clickedRows.size != 1" (click)="showDeleteDialog()">
      <fa-icon [icon]="faTrashCan"></fa-icon> Delete
    </button>
  </mat-toolbar>
</p>

<div class="tableContainer">
  <table mat-table [dataSource]="dataSource">
    <ng-container [matColumnDef]="'name'">
      <th mat-header-cell *matHeaderCellDef>Name</th>
      <td  mat-cell *matCellDef="let element">{{element.name}}</td>
    </ng-container>
    <ng-container [matColumnDef]="'image'">
      <th mat-header-cell *matHeaderCellDef>Image</th>
      <td  mat-cell *matCellDef="let element"><app-product-image [product]="element"></app-product-image></td>
    </ng-container>
    <ng-container [matColumnDef]="'description'">
      <th mat-header-cell *matHeaderCellDef>Description</th>
      <td  mat-cell *matCellDef="let element">{{element.description}}</td>
    </ng-container>
    <ng-container [matColumnDef]="'price'">
      <th mat-header-cell *matHeaderCellDef>Price</th>
      <td  mat-cell *matCellDef="let element">{{settingsHandlerService.getAmountFormatted(element.price || 0)}}</td>
    </ng-container>
    <ng-container [matColumnDef]="'category'">
      <th mat-header-cell *matHeaderCellDef>Category</th>
      <td  mat-cell *matCellDef="let element">
        <app-product-category [category]="element.category"></app-product-category>
      </td>
    </ng-container>
    <ng-container [matColumnDef]="'enabled'">
      <th mat-header-cell *matHeaderCellDef>Enabled</th>
      <td  mat-cell *matCellDef="let element"><fa-icon [icon]="element.enabled ? faCheck : faXmark"></fa-icon></td>
    </ng-container>
    <ng-container [matColumnDef]="'statistics'">
      <th mat-header-cell *matHeaderCellDef>Statistics</th>
      <td  mat-cell *matCellDef="let element"><fa-icon [icon]="element.displayStatistic ? faCheck : faXmark"></fa-icon></td>
    </ng-container>
    <ng-container [matColumnDef]="'creationtime'">
      <th mat-header-cell *matHeaderCellDef>Creation Time</th>
      <td  mat-cell *matCellDef="let element">{{settingsHandlerService.getTimestampFormatted(element.creationTime)}}</td>
    </ng-container>

    <tr mat-header-row *matHeaderRowDef="displayedColumns"></tr>
    <tr mat-row (click)="onRowClicked(row)" [class.selected]="clickedRows.has(row)" *matRowDef="let row; columns: displayedColumns;"></tr>

    <!-- Row shown when there is no matching data. -->
    <tr class="mat-row" *matNoDataRow>
      <td class="mat-cell" colspan="8">No data</td>
    </tr>
  </table>
  <mat-paginator [pageSizeOptions]="[10, 20, 50]"
                 showFirstLastButtons
                 aria-label="Select page of products">
  </mat-paginator>
</div>
